package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusConDebtExemptionReq;
import hls.core.csh.dto.HlsCusConDebtExemptionReqCf;
import hls.core.csh.service.ConDebtExemptionReqCfService;
import hls.core.csh.service.ConDebtExemptionReqService;
import hls.core.csh.service.IConContractCashflowService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * Created by haibin on 2017/7/25.
 */
@Component
public class ConDebtServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private SysUserService userService;
    @Autowired
    private ConDebtExemptionReqCfService conDebtExemptionReqCfService;
    @Autowired
    private IConContractCashflowService cashflowService;
    @Autowired
    private ConDebtExemptionReqService conDebtExemptionReqService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    @Override
    public void execute(DelegateExecution delegateExecution) {
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String cf = (String) delegateExecution.getVariable("conDebtExemptionReqCf");
        HlsCusConDebtExemptionReqCf conDebtExemptionReqCf = JSON.parseObject(cf, HlsCusConDebtExemptionReqCf.class);
        String result = (String) delegateExecution.getVariable("approveResult");
        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        List<HlsCusConDebtExemptionReqCf> list = conDebtExemptionReqCfService.selectExemptionReqCfById(conDebtExemptionReqCf);
        HlsCusConDebtExemptionReq conDebtExemptionReq = new HlsCusConDebtExemptionReq();
        conDebtExemptionReq.setChangeReqId(conDebtExemptionReqCf.getChangeReqId());
        conDebtExemptionReq = conDebtExemptionReqService.selectByPrimaryKey(requestCtx, conDebtExemptionReq);
        //lock CON_DEBT_EXEMPTION_REQ
        databaseLockProvider.lock(conDebtExemptionReq);

        for (HlsCusConDebtExemptionReqCf reqCf : list) {
            HlsCusConContractCashflow cashflow = new HlsCusConContractCashflow();
            cashflow.setCashflow_id(reqCf.getCashflowId());
            cashflow = cashflowService.selectByPrimaryKey(requestCtx, cashflow);
            cashflow.setDue_amount(cashflow.getDue_amount() - reqCf.getExemptionAmount());
            cashflow = cashflowService.updateByPrimaryKey(requestCtx, cashflow);
        }

        conDebtExemptionReq.setReqStatus("APPROVED");
        conDebtExemptionReq = conDebtExemptionReqService.updateByPrimaryKey(requestCtx, conDebtExemptionReq);
        List<HlsCusConDebtExemptionReqCf> cfList = conDebtExemptionReqCfService.selectExemptionReqCf(conDebtExemptionReqCf);
        for (HlsCusConDebtExemptionReqCf exemptionReqCf : cfList) {
            if (exemptionReqCf.getDelay_id() != null) {
                HlsCusConContractCashflow cashflow = new HlsCusConContractCashflow();
                cashflow.setCashflow_id(exemptionReqCf.getDelay_id());
                cashflow = cashflowService.selectByPrimaryKey(requestCtx, cashflow);
                cashflow.setPenalty_process_status("NORMAL");
                cashflowService.updateByPrimaryKey(requestCtx, cashflow);
            }
        }
    }
}
