package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.dto.HlsCusConDebtExemptionReq;
import hls.core.csh.dto.HlsCusConDebtExemptionReqCf;
import hls.core.csh.service.ConDebtExemptionReqCfService;
import hls.core.csh.service.ConDebtExemptionReqService;
import hls.core.csh.service.IConContractCashflowService;
import hls.core.sys.event.service.SysEventService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * Created by haibin on 2017/7/28.
 */
@Component
public class ConDebtStartActionTask implements JavaDelegate,IActivitiBean {

    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private ConDebtExemptionReqService conDebtExemptionReqService;
    @Autowired
    private ConDebtExemptionReqCfService conDebtExemptionReqCfService;
    @Autowired
    private IConContractCashflowService cashflowService;

    @Override
    public void execute(DelegateExecution delegateExecution) {
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String cf = (String)delegateExecution.getVariable("conDebtExemptionReqCf");
        HlsCusConDebtExemptionReqCf conDebtExemptionReqCf = JSON.parseObject(cf,HlsCusConDebtExemptionReqCf.class);
        HlsCusConDebtExemptionReq conDebtExemptionReq=new HlsCusConDebtExemptionReq();
        conDebtExemptionReq.setChangeReqId(conDebtExemptionReqCf.getChangeReqId());
        conDebtExemptionReq=conDebtExemptionReqService.selectByPrimaryKey(requestCtx,conDebtExemptionReq);
        conDebtExemptionReq.setReqStatus("APPROVING");
        conDebtExemptionReq.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        conDebtExemptionReq=conDebtExemptionReqService.updateByPrimaryKey(requestCtx,conDebtExemptionReq);
        List<HlsCusConDebtExemptionReqCf> list=conDebtExemptionReqCfService.selectExemptionReqCf(conDebtExemptionReqCf);
        for(HlsCusConDebtExemptionReqCf reqCf:list){
            if(reqCf.getDelay_id()!=null){
                HlsCusConContractCashflow cashflow=new HlsCusConContractCashflow();
                cashflow.setCashflow_id(reqCf.getDelay_id());
                cashflow=cashflowService.selectByPrimaryKey(requestCtx,cashflow);
                if(reqCf.getExemptionAmount()!=reqCf.getDueAmount()){
                    cashflow.setPenalty_process_status("SUSPEND");
                }else {
                    cashflow.setPenalty_process_status("EXEMPT");
                }
                cashflowService.updateByPrimaryKey(requestCtx,cashflow);
            }
        }
        sysEventService.createNotice(delegateExecution,"START");
    }
}