package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractCancel;
import hls.core.cont.service.ConContractCancelService;
import hls.core.cont.service.ConContractEventService;
import hls.core.cont.service.ConContractService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * Created by Administrator on 2017/4/24.
 */
@Component
public class ContractCancelServiceTask implements JavaDelegate, IActivitiBean {

    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private ConContractService contractService;
    @Autowired
    private ConContractCancelService cancelService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private ConContractEventService contractEventService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    public ContractCancelServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String cancel = (String) delegateExecution.getVariable("contractCancel");

        HlsCusConContractCancel contractCancel = JSON.parseObject(cancel,HlsCusConContractCancel.class);

        String result = (String) delegateExecution.getVariable("approveResult");
        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        HlsCusConContract cc = new HlsCusConContract();
        cc.setContractId(contractCancel.getContractId());
        cc = contractService.selectByPrimaryKey(requestCtx,cc);
        // lock con_contract
        databaseLockProvider.lock(cc);

        if ("APPROVED".equalsIgnoreCase(result)) {
            flag = "APPROVED";

            cc.setContractStatus("CANCEL");
            contractService.updateByPrimaryKeySelective(requestCtx, cc);
        } else if ("CANCEL".equalsIgnoreCase(result)) {
            flag = "CANCEL";
        } else {
            flag = "REJECTED";
        }

        HlsCusConContractCancel ccc = new HlsCusConContractCancel();
        ccc.setContractCancelId(contractCancel.getContractCancelId());
        ccc.setStatus(flag);
        ccc.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        cancelService.updateByPrimaryKeySelective(requestCtx, ccc);

        sysEventService.createEvent(requestCtx, contractCancel.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_CANCEL);

//        contractEventService.contractEvent(requestCtx, "CON_CONTRACT.CANCEL", contractCancel.getContractId(), Long.valueOf(sysUser.getUserId()));
    }
}
