package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractTermination;
import hls.core.cont.service.ConContractEventService;
import hls.core.cont.service.ConContractService;
import hls.core.cont.service.ConContractTerminationService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * Created by Administrator on 2017/4/18.
 */
@Component
public class ContractCompleteServiceTask implements JavaDelegate,IActivitiBean {

    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private ConContractService contractService;
    @Autowired
    private ConContractTerminationService  contractTerminationService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private ConContractEventService contractEventService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    public ContractCompleteServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String termination = (String)delegateExecution.getVariable("contractTermination");
        HlsCusConContractTermination contractTermination = JSON.parseObject(termination,HlsCusConContractTermination.class);
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        HlsCusConContract cc = new HlsCusConContract();
        cc.setContractId(contractTermination.getContractId());
        cc = contractService.selectByPrimaryKey(requestCtx,cc);
        // lock con_contract
        databaseLockProvider.lock(cc);

        if("APPROVED".equalsIgnoreCase(result))
        {
            flag ="APPROVED";

            cc.setTerminationDate(contractTermination.getTerminationDate());
            cc.setContractStatus("TERMINATE");
            cc.setReceivedStatus("FULL");
            contractService.updateByPrimaryKeySelective(requestCtx,cc);
        }else if("CANCEL".equalsIgnoreCase(result))
        {
            flag ="CANCEL";
        }else
        {
            flag ="REJECTED";
        }

        HlsCusConContractTermination cct = new HlsCusConContractTermination();
        cct.setContractTerminationId(contractTermination.getContractTerminationId());
        cct.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        cct.setStatus(flag);
        contractTerminationService.updateByPrimaryKeySelective(requestCtx,cct);

        sysEventService.createEvent(requestCtx, contractTermination.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_TERMINATION);

//        contractEventService.contractEvent(requestCtx,"CON_CONTRACT.TERMINATION",contractTermination.getContractId(),Long.valueOf(sysUser.getUserId()));

    }
}
