package com.hand.hap.activiti.components;

import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.activiti.exception.InsufficientAmountException;
import hls.core.csh.dto.HlsCusCshTransaction;
import hls.core.csh.dto.TransactionRelation;
import hls.core.csh.mapper.HlsCusCshTransactionMapper;
import hls.core.csh.mapper.TransactionRelationMapper;
import hls.core.hls.components.CalculateUtil;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * Created by fjm on 2017/10/9.
 */
@Component
public class ContractEarlyTerminationServiceTask implements JavaDelegate, IActivitiBean {

    public static final String CON_CONTRACT_CHANGE_REQ = "CON_CONTRACT_CHANGE_REQ";//合同变更
    @Autowired
    private TransactionRelationMapper transactionRelationMapper;
    @Autowired
    private HlsCusCshTransactionMapper transactionMapper;

    @Override
    public void execute(DelegateExecution execution) {
        String approveResult = (String) execution.getVariable("approveResult");
        if ("APPROVED".equalsIgnoreCase(approveResult)) {
            Double actualSettlement = (Double) execution.getVariable("actualSettlement");
            TransactionRelation relation = new TransactionRelation();
            String processInstanceBusinessKey = execution.getProcessInstanceBusinessKey();
            relation.setRelationDocId(Long.valueOf(processInstanceBusinessKey));
            relation.setRelationDocCategory(CON_CONTRACT_CHANGE_REQ);
            List<TransactionRelation> list = transactionRelationMapper.select(relation);
            Double totalReceiveAmount = 0D;
            for (TransactionRelation item : list) {
                Long transactionId = item.getTransactionId();
                HlsCusCshTransaction hlsCusCshTransaction = transactionMapper.selectByPrimaryKey(transactionId);
                totalReceiveAmount = CalculateUtil.add(totalReceiveAmount, CalculateUtil.sub(hlsCusCshTransaction.getTransactionAmount(), hlsCusCshTransaction.getWriteOffAmount()));
            }
            if (actualSettlement == null || actualSettlement.compareTo(totalReceiveAmount) == 1) {//判断收款金额是否大于实际结清金额
                try {
                    throw new InsufficientAmountException();
                } catch (InsufficientAmountException e) {
                    throw new RuntimeException(e);
                }
            }
        }

    }
}
