package com.hand.hap.activiti.components;

import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.cont.dto.*;
import hls.core.cont.mapper.*;
import hls.core.cont.service.ConContractEventService;
import hls.core.cont.service.IConFloatingRateReqLnService;
import hls.core.cont.service.IConFloatingRateReqService;
import hls.core.csh.dto.HlsCusConContractCashflow;
import hls.core.csh.mapper.HlsCusConContractCashflowMapper;
import hls.core.hls.components.DocumentChangeCommon;
import hls.core.hls.dto.HlsCusHlsDocumentVersionRel;
import hls.core.hls.dto.HlsDocumentVersionRel;
import hls.core.hls.mapper.HlsCusHlsDocumentVersionRelMapper;
import hls.core.prj.dto.HlsCusHlsDocumentVersion;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * Created by fjm on 2017/10/27.
 */
@Component
public class ContractFloatingRateServiceTask implements JavaDelegate, IActivitiBean {
    public static final String APPROVED = "APPROVED";
    public static final String CANCEL = "CANCEL";
    public static final String REJECTED = "REJECTED";
    public static final String CON_CONTRACT_H = "con_contract_h";
    public static final String CON_CONTRACT = "con_contract";
    public static final String CON_CONTRACT_CASHFLOW_H = "con_contract_cashflow_h";
    public static final String CON_CONTRACT_CASHFLOW = "con_contract_cashflow";
    public static final String DONE = "DONE";
    @Autowired
    private HlsCusConContractMapper contractMapper;
    @Autowired
    private HlsCusConContractHMapper contractHMapper;
    @Autowired
    private HlsCusConContractCashflowMapper cashflowMapper;
    @Autowired
    private HlsCusConContractCashflowHMapper cashflowHMapper;
    @Autowired
    private HlsCusHlsDocumentVersionRelMapper documentVersionRelMapper;
    @Autowired
    private DocumentChangeCommon documentChangeCommon;
    @Autowired
    private HlsCusConFloatingRateReqMapper floatingRateReqMapper;
    @Autowired
    private IConFloatingRateReqService floatingRateReqService;
    @Autowired
    private IConFloatingRateReqLnService floatingRateReqLnService;
    @Autowired
    private HlsCusConFloatingRateReqLnMapper floatingRateReqLnMapper;
    @Autowired
    private SysUserService userService;
    @Autowired
    private ConContractEventService contractEventService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    public ContractFloatingRateServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String result = (String) delegateExecution.getVariable("approveResult");
        String flag = null;
        if (APPROVED.equalsIgnoreCase(result)) {
            flag = APPROVED;
        } else if (CANCEL.equalsIgnoreCase(result)) {
            flag = CANCEL;
        } else {
            flag = REJECTED;
        }

        String processInstanceBusinessKey = delegateExecution.getProcessInstanceBusinessKey();
        Long changeReqId = Long.valueOf(processInstanceBusinessKey);
        HlsCusConFloatingRateReq conFloatingRateReq = floatingRateReqMapper.selectByPrimaryKey(changeReqId);
        HlsCusConFloatingRateReqLn floatingRateReqLn = new HlsCusConFloatingRateReqLn();
        floatingRateReqLn.setFltReqId(changeReqId);
        List<HlsCusConFloatingRateReqLn> floatingRateReqLns = floatingRateReqLnMapper.select(floatingRateReqLn);

        if (APPROVED.equalsIgnoreCase(flag)) {
            floatingRateReqLns.forEach(item -> {
                //插入历史类型的changeReq
                HlsCusHlsDocumentVersion documentVersion = documentChangeCommon.afterChangeRequest(requestCtx, item);
                Long versionId = documentVersion.getVersionId();
                Long contractId = item.getContractId();
                HlsCusConContract contract = contractMapper.selectByPrimaryKey(contractId);
                HlsCusConContractH contractH = documentChangeCommon.copyHistoryCommon(requestCtx, contract, null, versionId);

                Map map = new HashMap();
                map.put(DocumentChangeCommon.FIX_COLUMN_NAME, "contractId");
                map.put(DocumentChangeCommon.FIX_COLUMN_ID, contractH.getContractId());
                HlsCusConContractCashflow cashflow = new HlsCusConContractCashflow();
                cashflow.setContract_id(contractId);
                List<HlsCusConContractCashflow> cashflows = cashflowMapper.select(cashflow);
                cashflows.forEach(pro -> {
                    documentChangeCommon.copyHistoryCommon(requestCtx, pro, map, versionId);
                });

                //使用历史记录回盖原来的记录
                Long documentVersionId = item.getDocumentVersionId();
                HlsCusHlsDocumentVersionRel documentVersionRel = new HlsCusHlsDocumentVersionRel();
                documentVersionRel.setVersionId(documentVersionId);
                List<HlsCusHlsDocumentVersionRel> documentVersionRels = documentVersionRelMapper.select(documentVersionRel);
                //取出合同的rel
                HlsDocumentVersionRel hlsDocumentVersionRel = documentVersionRels.stream().filter(doc -> CON_CONTRACT.equalsIgnoreCase(doc.getFromTable()) && CON_CONTRACT_H.equalsIgnoreCase(doc.getToTable())).findFirst().get();
                //取出现金流的rel
                List<HlsDocumentVersionRel> collect = documentVersionRels.stream().filter(doc -> CON_CONTRACT_CASHFLOW.equalsIgnoreCase(doc.getFromTable()) && CON_CONTRACT_CASHFLOW_H.equalsIgnoreCase(doc.getToTable())).collect(Collectors.toList());
                Long toPk = hlsDocumentVersionRel.getToPk();
                Long fromPk = hlsDocumentVersionRel.getFromPk();
                HlsCusConContract oriContract = contractMapper.selectByPrimaryKey(fromPk);
                HlsCusConContractH hisContractH = contractHMapper.selectByPrimaryKey(toPk);
                //获得更新后的合同数据
                HlsCusConContract conContract = documentChangeCommon.recoverHistoryCommon(requestCtx, oriContract, hisContractH, null);
                //
                Map param = new HashMap();
                param.put(DocumentChangeCommon.FIX_COLUMN_NAME, "contractId");
                param.put(DocumentChangeCommon.FIX_COLUMN_ID, conContract.getContractId());

                collect.forEach(csh -> {
                    Long fromPkCsh = csh.getFromPk();
                    Long toPkCsh = csh.getToPk();
                    HlsCusConContractCashflow oriCashflow = cashflowMapper.selectByPrimaryKey(fromPkCsh);
                    HlsCusConContractCashflowH hisCashflow = cashflowHMapper.selectByPrimaryKey(toPkCsh);
                    documentChangeCommon.recoverHistoryCommon(requestCtx, oriCashflow, hisCashflow, param);
                });

                item.setStatus(DONE);
                floatingRateReqLnService.updateByPrimaryKeySelective(requestCtx,item);
            });
            conFloatingRateReq.setStatus(APPROVED);
        }else {
            //取消
            conFloatingRateReq.setStatus(REJECTED);
        }

        floatingRateReqService.updateByPrimaryKeySelective(requestCtx,conFloatingRateReq);

        //String employeeCode = (String) delegateExecution.getVariable("startUserName");

        //sysEventService.createEvent(requestCtx, contractSign.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_SIGN);

    }
}
