package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractIncept;
import hls.core.cont.service.ConContractEventService;
import hls.core.cont.service.ConContractInceptService;
import hls.core.cont.service.ConContractService;
import hls.core.gld.components.AbstractJeTrxService;
import hls.core.gld.components.JeTrxCommonService;
import hls.core.gld.dto.ContractTrx;
import hls.core.gld.service.IContractTrxService;
import hls.core.gld.service.IJeTrxDtlService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.HashMap;

/**
 * Created by Administrator on 2017/4/18.
 */
@Component
public class ContractInceptServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private ConContractInceptService contractInceptService;
    @Autowired
    private ConContractService contractService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private ConContractEventService contractEventService;
    @Autowired
    private IJeTrxDtlService jeTrxDtlService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private IContractTrxService contractTrxService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private JeTrxCommonService jeTrxCommonService;

    public ContractInceptServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String incept = (String)delegateExecution.getVariable("contractIncept");
        HlsCusConContractIncept contractIncept=JSON.parseObject(incept,HlsCusConContractIncept.class);

        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);

        HlsCusConContract cc = new HlsCusConContract();
        cc.setContractId(contractIncept.getContractId());
        cc = contractService.selectByPrimaryKey(requestCtx,cc);
        // lock con_contract
        databaseLockProvider.lock(cc);

        if("APPROVED".equalsIgnoreCase(result))
        {
            flag ="APPROVED";

            //插入凭证事务流水表

            cc.setContractStatus("INCEPT");
            cc.setInceptionOfLease(contractIncept.getInceptionOfLease());
            contractService.updateByPrimaryKeySelective(requestCtx,cc);
            cc = contractService.selectByPrimaryKey(requestCtx,cc);
            AbstractJeTrxService abstractJeTrxService = jeTrxCommonService.map.get("CONTRACT_INCEPT");
            HashMap map = new HashMap();
            map.put("jeTrxId", contractIncept.getContractInceptId());
            map.put("companyId", cc.getCompanyId());
            map.put("jeSourceDoc","CON_CONTRACT");
            map.put("jeSourceId", contractIncept.getContractId());
            map.put("contractId",contractIncept.getContractId());
            //jeTrxDtlService.jeTrxMade(requestCtx,map);
            abstractJeTrxService.process(requestCtx,map);

            //插入租赁合同收入事务表
            ContractTrx contractTrx = new ContractTrx();
            contractTrx.setCompanyId(cc.getCompanyId());
            contractTrx.setContractId(contractIncept.getContractId());
            contractTrx.setSourceType("CON_CONTRACT");
            contractTrx.setSourceId(contractIncept.getContractId());
            contractTrx.setStatus("NEW");
            contractTrxService.insertSelective(requestCtx,contractTrx);
        }else if("CANCEL".equalsIgnoreCase(result))
        {
            flag ="CANCEL";
        }else
        {
            flag ="REJECTED";
        }

        HlsCusConContractIncept cci = new HlsCusConContractIncept();
        cci.setContractInceptId(contractIncept.getContractInceptId());
        cci.setStatus(flag);
        cci.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        contractInceptService.updateByPrimaryKeySelective(requestCtx,cci);

        if(flag.equals("REJECTED")){
//            contractEventService.contractEvent(requestCtx,"CON_CONTRACT.INCEPT_REJECTED",contractIncept.getContractId(),Long.valueOf(sysUser.getUserId()));
        }else{
            sysEventService.createEvent(requestCtx, contractIncept.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_INCEPT);
//            contractEventService.contractEvent(requestCtx,"CON_CONTRACT.INCEPT",contractIncept.getContractId(),Long.valueOf(sysUser.getUserId()));
        }
    }
}
