package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.cont.dto.HlsCusConContract;
import hls.core.cont.dto.HlsCusConContractSign;
import hls.core.cont.service.ConContractEventService;
import hls.core.cont.service.ConContractService;
import hls.core.cont.service.ConContractSignService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * Created by Administrator on 2017/4/18.
 */
@Component
public class ContractSignServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private ConContractSignService contractSignService;
    @Autowired
    private ConContractService contractService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private ConContractEventService contractEventService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    public ContractSignServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String sign = (String)delegateExecution.getVariable("contractSign");
        HlsCusConContractSign contractSign= JSON.parseObject(sign,HlsCusConContractSign.class);

        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);

        HlsCusConContract cc = new HlsCusConContract();
        cc.setContractId(contractSign.getContractId());
        cc = contractService.selectByPrimaryKey(requestCtx,cc);
        // lock con_contract
        databaseLockProvider.lock(cc);
        if("APPROVED".equalsIgnoreCase(result))
        {
            flag ="APPROVED";


            cc.setContractStatus("SIGN");
            cc.setSignDate(contractSign.getSignDate());
            contractService.updateByPrimaryKeySelective(requestCtx,cc);
        }else if("CANCEL".equalsIgnoreCase(result))
        {
            flag ="CANCEL";
        }else
        {
            flag ="REJECTED";
        }

        HlsCusConContractSign cs = new HlsCusConContractSign();
        cs.setContractSignId(contractSign.getContractSignId());
        cs.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        cs.setStatus(flag);
        contractSignService.updateByPrimaryKeySelective(requestCtx,cs);

        //业务签约事件
        sysEventService.createEvent(requestCtx, contractSign.getContractId(), "CON_CONTRACT", "", null, SysEventCodeUtil.PROPERTY_CON_CONTRACT_SIGN);

//        contractEventService.contractEvent(requestCtx,"CON_CONTRACT.SIGN",contractSign.getContractId(),Long.valueOf(sysUser.getUserId()));

    }
}
