package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.*;
import hls.core.fct.service.HlsCreditLineApprovalService;
import hls.core.fct.service.HlsCreditLineChangeReqService;
import hls.core.fct.service.HlsCreditLineHService;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.service.ILonContractService;
import hls.core.prj.dto.HlsCusHlsCreditLine;
import hls.core.prj.service.HlsCreditLineService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by wangyan on 2017/11/13.
 */
@Component
public class CreditLineHSubmitServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private SysUserService userService;
    @Autowired
    private HlsCreditLineHService hlsCreditLineHService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private HlsCreditLineApprovalService hlsCreditLineApprovalService;
    @Autowired
    private HlsCreditLineService hlsCreditLineService;
    @Autowired
    private HlsBeanRefUtilService hlsBeanRefUtilService;
    @Autowired
    private HlsCreditLineChangeReqService hlsCreditLineChangeReqService;

    public CreditLineHSubmitServiceTask(){}
    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        String creditLinePrams = (String)delegateExecution.getVariable("hlsCreditLine");
        Long changeReqId = (Long)delegateExecution.getVariable("changeReqId");
        HlsCusHlsCreditLine hlsCreditLine = JSON.parseObject(creditLinePrams,HlsCusHlsCreditLine.class);
        HlsCusHlsCreditLine resulthlsCreditLine = new HlsCusHlsCreditLine();
        //根据状态修改额度信息
        resulthlsCreditLine.setCreditLineId(hlsCreditLine.getCreditLineId());
        resulthlsCreditLine = hlsCreditLineService.selectByPrimaryKey(requestCtx,resulthlsCreditLine);
        databaseLockProvider.lock(resulthlsCreditLine);
        if("APPROVED".equalsIgnoreCase(result)){
            flag = "APPROVED";
            Long creditLineId = hlsCreditLine.getCreditLineId();
            Long creditLineHId = hlsCreditLine.getCreditLineHId();
            Date validFromOld=hlsCreditLine.getValidFrom();
            String creditLineStatus = flag;
            HlsCusHlsCreditLineH resulthlsCreditLineH = new HlsCusHlsCreditLineH();
            resulthlsCreditLineH.setCreditLineId(creditLineHId);
            List<HlsCusHlsCreditLineH> list=new ArrayList<>();
            list=hlsCreditLineHService.queryVersionByPk(resulthlsCreditLineH);
            resulthlsCreditLineH.setCreditLineStatus(flag);
            hlsCreditLineHService.updateCreditLineHInfo(resulthlsCreditLineH);

            Map<String, String> map = hlsBeanRefUtilService.getFieldValueMap(list.get(0));
            hlsBeanRefUtilService.setFieldValue(hlsCreditLine, map);
            hlsCreditLine.setCreditLineId(creditLineId);
            hlsCreditLine.setCreditLineStatus(flag);
            Date validFrom=list.get(0).getValidFrom();
            Date validTo=list.get(0).getValidTo();
            Date now=new Date();
            Long term=validTo.getTime()-validFrom.getTime();
            SimpleDateFormat df=new SimpleDateFormat("yyyy-MM-dd");
            validTo=new Date(now.getTime() +term);
            hlsCreditLine.setValidFrom(validFromOld);
            hlsCreditLine.setValidTo(validTo);
            hlsCreditLineService.updateCreditlineInfo(hlsCreditLine);
        }else if("CANCEL".equalsIgnoreCase(result)){
            flag = "CANCEL";
            resulthlsCreditLine.setCreditLineStatus(flag);
            List<HlsCusHlsCreditLine> hlsCreditLineList=new ArrayList<>();
            resulthlsCreditLine.set__status("update");
            hlsCreditLineList.add(resulthlsCreditLine);
            hlsCreditLineService.batchUpdate(requestCtx,hlsCreditLineList);
        }else if("REJECTED".equalsIgnoreCase(result)){
            flag = "REJECT";
            Long creditLineId = hlsCreditLine.getCreditLineId();
            Long creditLineHId = hlsCreditLine.getCreditLineHId();
            String creditLineStatus = flag;
            HlsCusHlsCreditLineH resulthlsCreditLineH = new HlsCusHlsCreditLineH();
            resulthlsCreditLineH.setCreditLineId(creditLineHId);
            hlsCreditLineHService.updateCreditLineHInfo(resulthlsCreditLineH);
            resulthlsCreditLine.setCreditLineStatus("APPROVED");
            List<HlsCusHlsCreditLine> hlsCreditLineList=new ArrayList<>();
            resulthlsCreditLine.set__status("update");
            hlsCreditLineList.add(resulthlsCreditLine);
            hlsCreditLineService.batchUpdate(requestCtx,hlsCreditLineList);
        }
        //更新额度变更申请表
        HlsCusHlsCreditLineChangeReq hlsCusHlsCreditLineChangeReq = new HlsCusHlsCreditLineChangeReq();
        hlsCusHlsCreditLineChangeReq.setChangeReqId(changeReqId);
        hlsCusHlsCreditLineChangeReq=hlsCreditLineChangeReqService.selectByPrimaryKey(requestCtx,hlsCusHlsCreditLineChangeReq);
        hlsCusHlsCreditLineChangeReq.setStatus("APPROVED");
        hlsCreditLineChangeReqService.updateByPrimaryKey(requestCtx,hlsCusHlsCreditLineChangeReq);
    }

}
