package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.fct.dto.HlsCusFctProjectBp;
import hls.core.fct.dto.HlsCusHlsCreditLineApproval;
import hls.core.fct.dto.HlsCusHlsCreditLineH;
import hls.core.fct.mapper.HlsCusFctProjectBpMapper;
import hls.core.fct.mapper.HlsCusFctProjectMapper;
import hls.core.fct.service.FctProjectService;
import hls.core.fct.service.HlsCreditLineApprovalService;
import hls.core.fct.service.HlsCreditLineHService;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.prj.dto.HlsCusHlsCreditLine;
import hls.core.prj.service.HlsCreditLineService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by wangyan on 2017/11/13.
 */
@Component
public class CreditLineSubmitServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private SysUserService userService;
    @Autowired
    private HlsCreditLineService hlsCreditLineService;
    @Autowired
    private HlsCreditLineApprovalService hlsCreditLineApprovalService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private HlsBeanRefUtilService hlsBeanRefUtilService;
    @Autowired
    private HlsCreditLineHService hlsCreditLineHService;
    @Autowired
    private HlsCusFctProjectBpMapper hlsCusFctProjectBpMapper;
    @Autowired
    private HlsCusFctProjectMapper hlsCusFctProjectMapper;
    @Autowired
    private FctProjectService fctProjectService;

    public CreditLineSubmitServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String result = (String) delegateExecution.getVariable("approveResult");
        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        String creditLinePrams = (String) delegateExecution.getVariable("creditLine");
        HlsCusHlsCreditLine creditLine = JSON.parseObject(creditLinePrams, HlsCusHlsCreditLine.class);
        HlsCusHlsCreditLine resultCreditLine = new HlsCusHlsCreditLine();
        //根据状态修改额度信息
        resultCreditLine.setCreditLineId(creditLine.getCreditLineId());
        resultCreditLine = hlsCreditLineService.selectByPrimaryKey(requestCtx, resultCreditLine);
        //  resultCreditLine = hlsCreditLineService.selectByPrimaryKey(requestCtx,resultCreditLine);
        databaseLockProvider.lock(resultCreditLine);
        if ("APPROVED".equalsIgnoreCase(result)) {
            flag = "APPROVED";
            //插入变更历史表
            resultCreditLine.setCreditLineStatus(flag);
            Date validFrom = resultCreditLine.getValidFrom();
            Date validTo = resultCreditLine.getValidTo();
            Date now = new Date();
            Long term = validTo.getTime() - validFrom.getTime();
            SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
            validTo = new Date(now.getTime() + term);
            resultCreditLine.setValidFrom(new Date());
            resultCreditLine.setValidTo(validTo);
            hlsCreditLineService.updateByPrimaryKeySelective(requestCtx, resultCreditLine);
            //复制数据
            HlsCusHlsCreditLineH hlsCreditLineH = new HlsCusHlsCreditLineH();
            Map<String, String> map = hlsBeanRefUtilService.getFieldValueMap(resultCreditLine);
            hlsBeanRefUtilService.setFieldValue(hlsCreditLineH, map);
            hlsCreditLineH.setCreditLineId(null);
            hlsCreditLineH.setCreditLineStatus("NEW");
            hlsCreditLineH.set__status("add");
            List<HlsCusHlsCreditLineH> hlsCusHlsCreditLineHList = new ArrayList<>();
            hlsCusHlsCreditLineHList.add(hlsCreditLineH);
            hlsCreditLineHService.batchUpdate(requestCtx, hlsCusHlsCreditLineHList);

            //如果有项目之前没有占有综合授信，一旦项目上的授信方新建了一个综合授信，那么项目上的credit_comprehensive_id 更新为授信id ，一旦有值就不在修改
            HlsCusFctProjectBp fctProjectBp = new HlsCusFctProjectBp();
            fctProjectBp.setBpId(resultCreditLine.getBpId());
            fctProjectBp.setCreditGrantorParty("Y");
            List<HlsCusFctProjectBp> bp = hlsCusFctProjectBpMapper.fctProjectBpQuery(fctProjectBp);
            for (int i = 0; i < bp.size(); i++) {
                HlsCusFctProject fctProject = hlsCusFctProjectMapper.selectByPrimaryKey(bp.get(i).getProjectId());
                if (fctProject.getCreditComprehensiveId() == null) {
                    fctProject.setCreditComprehensiveId(resultCreditLine.getCreditLineId());
                }
                fctProjectService.updateByPrimaryKeySelective(requestCtx, fctProject);

            }

        } else if ("CANCEL".equalsIgnoreCase(result)) {
            flag = "CANCEL";
            resultCreditLine.setCreditLineStatus(flag);
            hlsCreditLineService.updateByPrimaryKeySelective(requestCtx, resultCreditLine);
        } else if ("APPROVED_RETURN".equalsIgnoreCase(result)) {
            flag = "APPROVED_RETURN";
            resultCreditLine.setCreditLineStatus(flag);
            hlsCreditLineService.updateByPrimaryKeySelective(requestCtx, resultCreditLine);
        }else if ("REJECTED".equalsIgnoreCase(result)) {
            flag = "REJECT";
            resultCreditLine.setCreditLineStatus(flag);
            hlsCreditLineService.updateByPrimaryKeySelective(requestCtx, resultCreditLine);
        }
        //结束流程插入授信审批表
        List<HlsCusHlsCreditLineApproval> hlsCreditLineApprovals = new ArrayList<>();
        HlsCusHlsCreditLineApproval hlsCreditLineApproval = new HlsCusHlsCreditLineApproval();
        hlsCreditLineApproval.setCreditLineId(creditLine.getCreditLineId());
        hlsCreditLineApproval.setStatus(flag);
        hlsCreditLineApproval.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        hlsCreditLineApprovals.add(hlsCreditLineApproval);
        hlsCreditLineApprovalService.insertSelective(requestCtx, hlsCreditLineApproval);
    }

}
