package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.csh.dto.HlsCusCshPaymentReqLn;
import hls.core.fct.dto.HlsCusFctContractWithdraw;
import hls.core.fct.service.FctContractWithdrawService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @Author: syj
 * @Description:
 * @Date: Created in 2017/10/19 10:57
 * @Modified By:
 */
@Component
public class FacSpecialPayExceptionServiceTask implements JavaDelegate, IActivitiBean {

    public static final String CSH_PAYMENT_FACT_EXCEPTION = "CSH_PAYMENT_FACT_EXCEPTION.SUMBIT";
    //付款特殊情况

    @Autowired
    private SysUserService userService;
    @Autowired
    private SysEventService sysEventService;

    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private FctContractWithdrawService fctContractWithdrawService;


    public FacSpecialPayExceptionServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        String fctContractWithdrawPrams=(String)delegateExecution.getVariable( "fctContractWithdraw");
        HlsCusFctContractWithdraw fctContractWithdraw=JSON.parseObject(fctContractWithdrawPrams,HlsCusFctContractWithdraw.class);
        HlsCusFctContractWithdraw resultFctContractWithdraw=new HlsCusFctContractWithdraw();
        resultFctContractWithdraw.setWithdrawId(fctContractWithdraw.getWithdrawId());
        resultFctContractWithdraw=fctContractWithdrawService.selectByPrimaryKey(requestCtx,resultFctContractWithdraw);
        databaseLockProvider.lock(resultFctContractWithdraw);
        if("APPROVED".equalsIgnoreCase(result)){
            flag = "SEPCIAL_REQUEST";
            resultFctContractWithdraw.setWithdrawStatus(flag);
            fctContractWithdrawService.updateByPrimaryKey(requestCtx,resultFctContractWithdraw);
        }else if("CANCEL".equalsIgnoreCase(result)){
            flag = "CANCEL";
        }else if("REJECTED".equalsIgnoreCase(result)){
            flag = "APPROVED_RETURN";
        }

    }
}
