package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.*;
import hls.core.fct.mapper.HlsCusFctProjectBasicTrxDtlMapper;
import hls.core.fct.service.*;
import hls.core.hls.service.HlsBeanRefUtilService;
import hls.core.sys.dto.SysDocumentList;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.mapper.SysDocumentListMapper;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by cyy on 2017/12/8
 * 用款需求申请 审批结束
 */

@Component
public class FctCashDemandServiceTask implements JavaDelegate, IActivitiBean {


    @Autowired
    private FctContractWithdrawService fctContractWithdrawService;
    @Autowired
    private SysUserService userService;

    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private FctContractWithdrawAprlService fctContractWithdrawAprlService;
    @Autowired
    private HlsCusFctProjectBasicTrxDtlMapper fctProjectBasicTrxDtlMapper;
    @Autowired
    private FctProjectBasicTrxDtlService fctProjectBasicTrxDtlService;
    @Autowired
    private FctContractService fctContractService;
    @Autowired
    private SysDocumentListMapper sysDocumentListMapper;
    @Autowired
    private FctPaymentTermService fctPaymentTermService;
    @Autowired
    private  FctProjectPaymentTermService fctProjectPaymentTermService;
    @Autowired
    private IFctContractWithdrawPtService iFctContractWithdrawPtService;
    @Autowired
    private HlsBeanRefUtilService hlsBeanRefUtilService;


    public static final String PROPERTY_FCT_CASH_DEMAND_APPROVED = "FCT_WITHDRAW_REQUEST.APPROVED";
    public static final String PROPERTY_FCT_CASH_DEMAND_REJECT = "FCT_WITHDRAW_REQUEST.REJECT";
    public static final String PROPERTY_FCT_CASH_DEMAND_CANCEL = "FCT_WITHDRAW_REQUEST.CANCEL";

    public FctCashDemandServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        String flagDesc = null;
        String evenCode = null;
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String result = (String) delegateExecution.getVariable("approveResult");
        String hlsCusFctContractWithdraw = (String) delegateExecution.getVariable("hlsCusFctContractWithdraw");
        HlsCusFctContractWithdraw fctContractWithdraw = JSON.parseObject(hlsCusFctContractWithdraw, HlsCusFctContractWithdraw.class);
        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);

        HlsCusFctContractWithdraw withdraw = new HlsCusFctContractWithdraw();
        withdraw.setWithdrawId(fctContractWithdraw.getWithdrawId());
        withdraw = fctContractWithdrawService.selectByPrimaryKey(requestCtx, withdraw);
        // lock con_contract
        databaseLockProvider.lock(withdraw);
        if ("APPROVED".equalsIgnoreCase(result)) {
            flag = "APPROVED";
            flagDesc = "通过";
            evenCode = PROPERTY_FCT_CASH_DEMAND_APPROVED;
            withdraw.setWithdrawStatus("WITHDRAW_REQUEST");
            fctContractWithdrawService.updateByPrimaryKeySelective(requestCtx, withdraw);

            //更新保理项目基础交易明细表
            HlsCusFctProjectBasicTrxDtl hlsCusFctProjectBasicTrxDtl = new HlsCusFctProjectBasicTrxDtl();
            hlsCusFctProjectBasicTrxDtl.setWithdrawId(withdraw.getWithdrawId());
            List<HlsCusFctProjectBasicTrxDtl> fctProjectBasicTrxDtl = new ArrayList<>();
            fctProjectBasicTrxDtl=fctProjectBasicTrxDtlMapper.fctContractWithdrawTrxDtl(hlsCusFctProjectBasicTrxDtl);
           for(HlsCusFctProjectBasicTrxDtl dt:fctProjectBasicTrxDtl ){
               if(dt.getTrxArAmountUsed()==null){
                   dt.setTrxArAmountUsed(0D);
               }
               dt.setTrxArAmountUsed(dt.getUseAmount()+dt.getTrxArAmountUsed());
               dt.set__status("update");
           }
            fctProjectBasicTrxDtlService.batchUpdate(requestCtx,fctProjectBasicTrxDtl);
        } else if ("CANCEL".equalsIgnoreCase(result)) {
            flag = "CANCEL";
            flagDesc = "取消";
            evenCode = PROPERTY_FCT_CASH_DEMAND_CANCEL;
        } else {
            flag = "REJECTED";
            flagDesc = "拒绝";
            withdraw.setWithdrawStatus("REJECT");
            evenCode = PROPERTY_FCT_CASH_DEMAND_REJECT;
            fctContractWithdrawService.updateByPrimaryKeySelective(requestCtx, withdraw);
        }

        Long withdrawApprovalId = (Long) delegateExecution.getVariable("withdrawApprovalId");

        //保理合同提款单审批表
        HlsCusFctContractWithdrawAprl hlsCusFctContractWithdrawAprl = new HlsCusFctContractWithdrawAprl();
        hlsCusFctContractWithdrawAprl.setWithdrawApprovalId(withdrawApprovalId);
        hlsCusFctContractWithdrawAprl.setStatus(flag);
        hlsCusFctContractWithdrawAprl.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        fctContractWithdrawAprlService.updateByPrimaryKeySelective(requestCtx, hlsCusFctContractWithdrawAprl);
        //插入对应付款前提条件
//        List<SysDocumentList> sysDocumentListList=new ArrayList<>();
//        sysDocumentListList=sysDocumentListMapper.sysDocumentListQueryFzzj();
//        if(sysDocumentListList.size()!=0){
//            for(SysDocumentList dt:sysDocumentListList){
//                HlsCusFctPaymentTerm fctPaymentTerm=new HlsCusFctPaymentTerm();
//                fctPaymentTerm.setCompanyId(requestCtx.getCompanyId());
//                fctPaymentTerm.setPaymentTermName(dt.getDocumentListName());
//                fctPaymentTerm.setEnabledFlag("Y");
//                fctPaymentTerm=fctPaymentTermService.insertSelective(requestCtx,fctPaymentTerm);
//                HlsCusFctProjectPaymentTerm fctProjectPaymentTerm=new HlsCusFctProjectPaymentTerm();
//                Map<String, String> map = hlsBeanRefUtilService.getFieldValueMap(fctPaymentTerm);
//                hlsBeanRefUtilService.setFieldValue(fctProjectPaymentTerm, map);
//                fctProjectPaymentTerm=fctProjectPaymentTermService.insertSelective(requestCtx,fctProjectPaymentTerm);
//                HlsCusFctContractWithdrawPt fctContractWithdrawPt=new HlsCusFctContractWithdrawPt();
//                fctContractWithdrawPt.setProjectPaymentTermId(fctProjectPaymentTerm.getPrjPaymentTermId());
//                fctContractWithdrawPt.setWithdrawId(fctContractWithdraw.getWithdrawId());
//                fctContractWithdrawPt.setApplyFlag("N");
//                fctContractWithdrawPt.setSatisfyFlag("Y");
//                fctContractWithdrawPt.setWithdrawPaymentTermName(fctProjectPaymentTerm.getPaymentTermName());
//                fctContractWithdrawPt=iFctContractWithdrawPtService.insertSelective(requestCtx,fctContractWithdrawPt);
//            }
//        }
        Map<String, Object> evenParams = new HashMap<>();
        evenParams.put("message", "保理提款" + withdraw.getWithdrawName() + "用款需求申请审批" + flagDesc);
        evenParams.put("noticeTitle", "保理提款用款需求申请审批");
        evenParams.put("url", "");
        evenParams.put("level", 1L);
        evenParams.put("noticeType", "NOTICE");
        sysEventService.eventSave(requestCtx, withdraw.getWithdrawId(), withdraw.getDocumentCategory(), withdraw.getDocumentType(), "FCT", evenCode, "P2D", evenParams);
    }
}
