package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.fct.dto.HlsCusFctProjectConFileAprl;
import hls.core.fct.service.FctProjectConFileAprlService;
import hls.core.fct.service.FctProjectService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by SYJ on 2017/11/16.
 */
@Component
public class FctContractContentServiceTask implements JavaDelegate, IActivitiBean {


    @Autowired
    private FctProjectService fctProjectService;
    @Autowired
    private SysUserService userService;

    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private FctProjectConFileAprlService fctProjectConFileAprlService;

    public static final String PROPERTY_FCT_CONTRACT_CONTENT_SUBMIT = "FCT_PROJECT.CONTENT.SUBMIT";

    public FctContractContentServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        String flagDesc = null;
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String result = (String) delegateExecution.getVariable("approveResult");
        String project = (String) delegateExecution.getVariable("fctProject");
        HlsCusFctProject fctproject = JSON.parseObject(project, HlsCusFctProject.class);

        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        HlsCusFctProject cc = new HlsCusFctProject();
        cc.setProjectId(fctproject.getProjectId());
        cc = fctProjectService.selectByPrimaryKey(requestCtx, cc);
        // lock con_contract
        databaseLockProvider.lock(cc);
        if ("APPROVED".equalsIgnoreCase(result)) {
            flag = "APPROVED";
            flagDesc = "通过";
            cc.setContractStatus("FILE_APPROVED");
            fctProjectService.updateByPrimaryKeySelective(requestCtx, cc);
        } else if ("CANCEL".equalsIgnoreCase(result)) {
            flag = "CANCEL";
            flagDesc = "取消";
        } else {
            flag = "REJECTED";
            flagDesc = "拒绝";
            cc.setContractStatus("REJECT");
            fctProjectService.updateByPrimaryKeySelective(requestCtx, cc);
        }

        HlsCusFctProjectConFileAprl fctProjectConFileAprl = new HlsCusFctProjectConFileAprl();
        fctProjectConFileAprl.setProjectId(cc.getProjectId());
        fctProjectConFileAprl.setStatus(flag);
        fctProjectConFileAprl.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        fctProjectConFileAprlService.insertSelective(requestCtx, fctProjectConFileAprl);


        Map<String, Object> evenParams = new HashMap<>();
        evenParams.put("message", "保理项目" + cc.getProjectNumber() + "合同文本审批" + flagDesc);
        evenParams.put("noticeTitle", "合同文本审批");
        evenParams.put("url", "");
        evenParams.put("level", 1L);
        evenParams.put("noticeType", "NOTICE");
        sysEventService.eventSave(requestCtx, cc.getProjectId(), cc.getDocumentCategory(), cc.getDocumentType(), "FCT", PROPERTY_FCT_CONTRACT_CONTENT_SUBMIT, "P2D", evenParams);
    }
}
