package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.csh.mapper.HlsCusCshPaymentReqLnMapper;
import hls.core.csh.service.ICshPaymentReqLnService;
import hls.core.fct.dto.FctContract;
import hls.core.fct.dto.HlsCusFctContractWithdraw;
import hls.core.fct.dto.HlsCusFctContractWithdrawAprl;
import hls.core.fct.dto.HlsCusFctContractWithdrawPt;
import hls.core.fct.mapper.HlsCusFctContractWithdrawCfMapper;
import hls.core.fct.service.FctContractService;
import hls.core.fct.service.FctContractWithdrawAprlService;
import hls.core.fct.service.FctContractWithdrawService;
import hls.core.fct.service.IFctContractWithdrawPtService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by SYJ on 2017/12/8
 * 特殊情况申请 审批结束
 */

@Component
public class FctContractWithdrawSpclServiceTask implements JavaDelegate, IActivitiBean {


    @Autowired
    private FctContractWithdrawService fctContractWithdrawService;
    @Autowired
    private SysUserService userService;

    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private FctContractWithdrawAprlService fctContractWithdrawAprlService;
    @Autowired
    private IFctContractWithdrawPtService fctContractWithdrawPtService;
    @Autowired
    private FctContractService fctContractService;
    @Autowired
    private HlsCusFctContractWithdrawCfMapper fctContractWithdrawCfMapper;
    @Autowired
    private ICshPaymentReqLnService cshPaymentReqLnService;
    @Autowired
    private HlsCusCshPaymentReqLnMapper hlsCusCshPaymentReqLnMapper;


    public static final String PROPERTY_FCT_SPECIAL_REQUEST_APPROVED = "FCT_SPECIAL_REQUEST.APPROVED";
    public static final String PROPERTY_FCT_SPECIAL_REQUEST_REJECT = "FCT_SPECIAL_REQUEST.REJECT";
    public static final String PROPERTY_FCT_SPECIAL_REQUEST_CANCEL = "FCT_SPECIAL_REQUEST.CANCEL";

    public FctContractWithdrawSpclServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        String flagDesc = null;
        String evenCode = null;
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String result = (String) delegateExecution.getVariable("approveResult");
        String hlsCusFctContractWithdraw = (String) delegateExecution.getVariable("hlsCusFctContractWithdraw");
        HlsCusFctContractWithdraw fctContractWithdraw = JSON.parseObject(hlsCusFctContractWithdraw, HlsCusFctContractWithdraw.class);
        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);

        HlsCusFctContractWithdraw withdraw = new HlsCusFctContractWithdraw();
        withdraw.setWithdrawId(fctContractWithdraw.getWithdrawId());
        withdraw = fctContractWithdrawService.selectByPrimaryKey(requestCtx, withdraw);
        // lock con_contract
        databaseLockProvider.lock(withdraw);
        if ("APPROVED".equalsIgnoreCase(result)) {
            flag = "APPROVED";
            flagDesc = "通过";
            evenCode = PROPERTY_FCT_SPECIAL_REQUEST_APPROVED;
            withdraw.setWithdrawStatus("SPECIAL_REQUEST");
            fctContractWithdrawService.updateByPrimaryKeySelective(requestCtx, withdraw);

        } else if ("CANCEL".equalsIgnoreCase(result)) {
            flag = "CANCEL";
            flagDesc = "取消";
            evenCode = PROPERTY_FCT_SPECIAL_REQUEST_CANCEL;
        } else {
            flag = "REJECTED";
            flagDesc = "拒绝";
            withdraw.setWithdrawStatus("ADVANCES_RECEIVED");
            //TODO 拒绝后将 特殊情况申请 的 apply_flag 字段修改为N
            HlsCusFctContractWithdrawPt fctContractWithdrawPt=new HlsCusFctContractWithdrawPt();
            fctContractWithdrawPt.setWithdrawId(withdraw.getWithdrawId());
            fctContractWithdrawPtService.updateByWithdrawId(fctContractWithdrawPt);
            evenCode = PROPERTY_FCT_SPECIAL_REQUEST_REJECT;
            fctContractWithdrawService.updateByPrimaryKeySelective(requestCtx, withdraw);
        }

        Long withdrawApprovalId = (Long) delegateExecution.getVariable("withdrawApprovalId");

        //更新授信审批表
        HlsCusFctContractWithdrawAprl hlsCusFctContractWithdrawAprl = new HlsCusFctContractWithdrawAprl();
        hlsCusFctContractWithdrawAprl.setWithdrawApprovalId(withdrawApprovalId);
        hlsCusFctContractWithdrawAprl.setStatus(flag);
        hlsCusFctContractWithdrawAprl.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        fctContractWithdrawAprlService.updateByPrimaryKeySelective(requestCtx, hlsCusFctContractWithdrawAprl);


        Map<String, Object> evenParams = new HashMap<>();
        evenParams.put("message", "保理提款" + withdraw.getWithdrawName() + "特殊情况申请审批" + flagDesc);
        evenParams.put("noticeTitle", "保理特殊情况申请审批");
        evenParams.put("url", "");
        evenParams.put("level", 1L);
        evenParams.put("noticeType", "NOTICE");
        sysEventService.eventSave(requestCtx, withdraw.getWithdrawId(), withdraw.getDocumentCategory(), withdraw.getDocumentType(), "FCT", evenCode, "P2D", evenParams);
    }
}
