package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.HlsCusFctContract;
import hls.core.fct.dto.HlsCusFctContractTermination;
import hls.core.fct.mapper.HlsCusFctProjectQuotationMapper;
import hls.core.fct.service.*;
import hls.core.prj.service.HlsCreditLineService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by xuju on 2017/11/13.
 */
@Component
public class FctContractWriteOffSubmitServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private SysUserService userService;
    @Autowired
    private FctProjectService fctProjectService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private FctProjectApprovalService fctProjectApprovalService;
    @Autowired
    private FctProjectQuotationService fctProjectQuotationService;
    @Autowired
    private  HlsCusFctProjectQuotationMapper fctProjectQuotationMapper;
    @Autowired
    private HlsCreditLineService hlsCreditLineService;
    @Autowired
    private FctContractTerminationService fctContractTerminationService;
    @Autowired
    private FctContractService fctContractService;

    public FctContractWriteOffSubmitServiceTask(){}

    public static final String PROPERTY_FCT_CONTRACT_WRITEOFF_SUBMIT = "FCT_CONTRACT.WRITEOFF.SUBMIT";

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        String flagDesc = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        String fctContractPrams=(String)delegateExecution.getVariable( "fctContract");
        String fctContractTerminationPrams=(String)delegateExecution.getVariable( "fctContractTermination");
        HlsCusFctContract fctContract=JSON.parseObject(fctContractPrams, HlsCusFctContract.class);
        HlsCusFctContractTermination fctContractTermination=JSON.parseObject(fctContractTerminationPrams, HlsCusFctContractTermination.class);
        HlsCusFctContract resultFctContract=new HlsCusFctContract();
        //根据状态修改立项信息
        resultFctContract.setContractId(fctContract.getContractId());
        resultFctContract=fctContractService.selectByPrimaryKey(requestCtx,resultFctContract);
        databaseLockProvider.lock(resultFctContract);
        if("APPROVED".equalsIgnoreCase(result)){
            flag = "APPROVED";
            flagDesc="审批通过";
            resultFctContract.setContractStatus("TERMINATE");
            fctContractService.updateByPrimaryKeySelective(requestCtx,resultFctContract);
            fctContractTermination.setStatus("APPROVED");
            fctContractTerminationService.updateByPrimaryKey(requestCtx,fctContractTermination);
        }else if("CANCEL".equalsIgnoreCase(result)){
            flag = "CANCEL";
            flagDesc="审批取消";
        }else if("REJECTED".equalsIgnoreCase(result)){
            flag = "APPROVED_RETURN";
            flagDesc="审批退回";
            fctContractTermination.setStatus("REJECTED");
            fctContractTerminationService.updateByPrimaryKey(requestCtx,fctContractTermination);
        }

        Map<String, Object> evenParams = new HashMap<>();
        evenParams.put("message", "保理合同" + resultFctContract.getContractNumber() + "结清审批" + flagDesc);
        evenParams.put("noticeTitle", "保理合同结清申请审批");
        evenParams.put("url", "");
        evenParams.put("level", 1L);
        evenParams.put("noticeType", "NOTICE");
        sysEventService.eventSave(requestCtx, resultFctContract.getContractId(), resultFctContract.getDocumentCategory(), resultFctContract.getDocumentType(), "FCT", PROPERTY_FCT_CONTRACT_WRITEOFF_SUBMIT, "P2D", evenParams);

    }

}
