package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.csh.dto.HlsCusCshPaymentReqHd;
import hls.core.csh.dto.HlsCusCshPaymentReqLn;
import hls.core.csh.mapper.HlsCusCshPaymentReqLnMapper;
import hls.core.csh.service.ICshPaymentReqHdService;
import hls.core.csh.service.ICshPaymentReqLnService;
import hls.core.fct.dto.HlsCusFctContractWithdraw;
import hls.core.fct.dto.HlsCusFctContractWithdrawAprl;
import hls.core.fct.dto.HlsCusFctContractWithdrawCf;
import hls.core.fct.mapper.HlsCusFctContractWithdrawCfMapper;
import hls.core.fct.service.FctContractService;
import hls.core.fct.service.FctContractWithdrawAprlService;
import hls.core.fct.service.FctContractWithdrawService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by SYJ on 2017/12/8
 * 保理付款申请 审批结束
 */

@Component
public class FctPaymentRequestServiceTask implements JavaDelegate, IActivitiBean {


    @Autowired
    private FctContractWithdrawService fctContractWithdrawService;
    @Autowired
    private SysUserService userService;

    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private FctContractWithdrawAprlService fctContractWithdrawAprlService;
    @Autowired
    private FctContractService fctContractService;
    @Autowired
    private HlsCusFctContractWithdrawCfMapper fctContractWithdrawCfMapper;
    @Autowired
    private ICshPaymentReqLnService cshPaymentReqLnService;
    @Autowired
    private HlsCusCshPaymentReqLnMapper hlsCusCshPaymentReqLnMapper;


    @Autowired
    private ICshPaymentReqHdService paymentReqHdService;


    public static final String PROPERTY_FCT_PAYMENT_REQUEST_APPROVED = "FCT_PAYMENT_REQUEST.APPROVED";
    public static final String PROPERTY_FCT_PAYMENT_REQUEST_REJECT = "FCT_PAYMENT_REQUEST.REJECT";
    public static final String PROPERTY_FCT_PAYMENT_REQUEST_CANCEL = "FCT_PAYMENT_REQUEST.CANCEL";

    public FctPaymentRequestServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        String flagDesc = null;
        String evenCode = null;
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String result = (String) delegateExecution.getVariable("approveResult");
        String hlsCusFctContractWithdraw = (String) delegateExecution.getVariable("hlsCusFctContractWithdraw");
        HlsCusFctContractWithdraw fctContractWithdraw = JSON.parseObject(hlsCusFctContractWithdraw, HlsCusFctContractWithdraw.class);
        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);

        HlsCusFctContractWithdraw withdraw = new HlsCusFctContractWithdraw();
        withdraw.setWithdrawId(fctContractWithdraw.getWithdrawId());
        withdraw = fctContractWithdrawService.selectByPrimaryKey(requestCtx, withdraw);
        // lock con_contract
        databaseLockProvider.lock(withdraw);
        if ("APPROVED".equalsIgnoreCase(result)) {
            flag = "APPROVED";
            flagDesc = "通过";
            evenCode = PROPERTY_FCT_PAYMENT_REQUEST_APPROVED;
            withdraw.setWithdrawStatus("PAYMENT_REQUEST");
            fctContractWithdrawService.updateByPrimaryKeySelective(requestCtx, withdraw);


            HlsCusCshPaymentReqHd hd = new HlsCusCshPaymentReqHd();
            Long paymentReqId = (Long) delegateExecution.getVariable("paymentReqId");
            hd.setPayment_req_id(paymentReqId);
            hd =paymentReqHdService.selectByPrimaryKey(requestCtx,hd);
            hd.setPayment_req_status("APPROVED");
            paymentReqHdService.updateByPrimaryKeySelective(requestCtx, hd);

            //插入outflow现金流
            fctContractService.insertOutFlowCf(requestCtx, withdraw,hd.getApply_pay_date());

            HlsCusFctContractWithdrawCf cf = new HlsCusFctContractWithdrawCf();
            cf.setWithdrawId(withdraw.getWithdrawId());
            cf.setContractId(withdraw.getContractId());
            cf.setCfItem(40L);
            cf.setTimes(0L);
            cf=fctContractWithdrawCfMapper.fctContractWithdrawCfDetailQuery(cf).get(0);

            //更新付款行上 Source_doc_line_id
            HlsCusCshPaymentReqLn ln = new HlsCusCshPaymentReqLn();
            Long paymentReqLnId = (Long) delegateExecution.getVariable("paymentReqLnId");
            ln.setPayment_req_ln_id(paymentReqLnId);
            ln = hlsCusCshPaymentReqLnMapper.selectByPrimaryKey(ln);
            ln.setSource_doc_line_id(cf.getWithdrawCfId());
            cshPaymentReqLnService.updateByPrimaryKeySelective(requestCtx, ln);




        } else if ("CANCEL".equalsIgnoreCase(result)) {
            flag = "CANCEL";
            flagDesc = "取消";
            evenCode = PROPERTY_FCT_PAYMENT_REQUEST_CANCEL;
        } else {
            flag = "REJECTED";
            flagDesc = "拒绝";
            withdraw.setWithdrawStatus("WITHDRAW_REQUEST");
            evenCode = PROPERTY_FCT_PAYMENT_REQUEST_REJECT;
            fctContractWithdrawService.updateByPrimaryKeySelective(requestCtx, withdraw);

            HlsCusCshPaymentReqHd hd = new HlsCusCshPaymentReqHd();
            Long paymentReqId = (Long) delegateExecution.getVariable("paymentReqId");
            hd.setPayment_req_id(paymentReqId);
            hd =paymentReqHdService.selectByPrimaryKey(requestCtx,hd);
            hd.setPayment_req_status("REJECT");
            paymentReqHdService.updateByPrimaryKeySelective(requestCtx, hd);

        }

        Long withdrawApprovalId = (Long) delegateExecution.getVariable("withdrawApprovalId");

        //更新授信审批表
        HlsCusFctContractWithdrawAprl hlsCusFctContractWithdrawAprl = new HlsCusFctContractWithdrawAprl();
        hlsCusFctContractWithdrawAprl.setWithdrawApprovalId(withdrawApprovalId);
        hlsCusFctContractWithdrawAprl.setStatus(flag);
        hlsCusFctContractWithdrawAprl.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        fctContractWithdrawAprlService.updateByPrimaryKeySelective(requestCtx, hlsCusFctContractWithdrawAprl);


        Map<String, Object> evenParams = new HashMap<>();
        evenParams.put("message", "保理提款" + withdraw.getWithdrawName() + "付款申请审批" + flagDesc);
        evenParams.put("noticeTitle", "保理提款付款申请审批");
        evenParams.put("url", "");
        evenParams.put("level", 1L);
        evenParams.put("noticeType", "NOTICE");
        sysEventService.eventSave(requestCtx, withdraw.getWithdrawId(), withdraw.getDocumentCategory(), withdraw.getDocumentType(), "FCT", evenCode, "P2D", evenParams);
    }
}
