package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.HlsCusFctProjectBasicTrx;
import hls.core.fct.dto.HlsCusFctProjectBasicTrxAprl;
import hls.core.fct.service.FctProjectBasicTrxAprlService;
import hls.core.fct.service.FctProjectBasicTrxService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * Created by wangyan on 2017/11/13.
 */
@Component
public class FctProjectBasicTrxSubmitServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private SysUserService userService;
    @Autowired
    private FctProjectBasicTrxService fctProjectBasicTrxService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private FctProjectBasicTrxAprlService fctProjectBasicTrxAprlService;

    public FctProjectBasicTrxSubmitServiceTask(){}
    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        String fctProjectBasicTrxPrams = (String)delegateExecution.getVariable("fctProjectBasicTrx");
        HlsCusFctProjectBasicTrx fctProjectBasicTrx = JSON.parseObject(fctProjectBasicTrxPrams,HlsCusFctProjectBasicTrx.class);
        HlsCusFctProjectBasicTrx resultfctProjectBasicTrx = new HlsCusFctProjectBasicTrx();
        //根据状态修改额度信息
        resultfctProjectBasicTrx.setBasicTrxId(fctProjectBasicTrx.getBasicTrxId());
        resultfctProjectBasicTrx = fctProjectBasicTrxService.selectByPrimaryKey(requestCtx,resultfctProjectBasicTrx);
        databaseLockProvider.lock(resultfctProjectBasicTrx);
        if("APPROVED".equalsIgnoreCase(result)){
            flag = "APPROVED";
        }else if("CANCEL".equalsIgnoreCase(result)){
            flag = "CANCEL";
        }else if("REJECTED".equalsIgnoreCase(result)){
            flag = "APPROVED_RETURN";
        }
        resultfctProjectBasicTrx.setBasicDealsStatus(flag);
        //插入审批表
        HlsCusFctProjectBasicTrxAprl fctProjectBasicTrxAprl = new HlsCusFctProjectBasicTrxAprl();
        fctProjectBasicTrxAprl.setBasicTrxId(fctProjectBasicTrx.getBasicTrxId());
        fctProjectBasicTrxAprl.setProjectId(fctProjectBasicTrx.getProjectId());
        fctProjectBasicTrxAprl.setStatus(flag);
        fctProjectBasicTrxAprlService.updateByPrimaryKey(requestCtx,fctProjectBasicTrxAprl);
        fctProjectBasicTrxService.updateByPrimaryKeySelective(requestCtx,resultfctProjectBasicTrx);
    }

}
