package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.fct.dto.HlsCusHlsCreditLineApproval;
import hls.core.fct.service.FctProjectConFileAprlService;
import hls.core.fct.service.FctProjectService;
import hls.core.fct.service.HlsCreditLineApprovalService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by SYJ on 2017/11/16.
 */
@Component
public class FctProjectCreditServiceTask implements JavaDelegate, IActivitiBean {


    @Autowired
    private FctProjectService fctProjectService;
    @Autowired
    private SysUserService userService;

    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private FctProjectConFileAprlService fctProjectConFileAprlService;
    @Autowired
    private HlsCreditLineApprovalService hlsCreditLineApprovalService;

    public static final String PROPERTY_FCT_PROJECT_CREDIT_SUBMIT = "FCT_PROJECT_CREDIT.SUBMIT";

    public FctProjectCreditServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        String flagDesc = null;
        IRequest requestCtx = (IRequest) delegateExecution.getVariable("iRequest");
        String result = (String) delegateExecution.getVariable("approveResult");
        String project = (String) delegateExecution.getVariable("fctProject");
        HlsCusFctProject fctproject = JSON.parseObject(project, HlsCusFctProject.class);

        String employeeCode = (String) delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        HlsCusFctProject cc = new HlsCusFctProject();
        cc.setProjectId(fctproject.getProjectId());
        cc = fctProjectService.selectByPrimaryKey(requestCtx, cc);
        // lock con_contract
        databaseLockProvider.lock(cc);
        if ("APPROVED".equalsIgnoreCase(result)) {
            flag = "APPROVED";
            flagDesc = "通过";
            cc.setCreditStatus("APPROVED");
            fctProjectService.updateByPrimaryKeySelective(requestCtx, cc);
        } else if ("CANCEL".equalsIgnoreCase(result)) {
            flag = "CANCEL";
            flagDesc = "取消";
        } else if("REJECTED".equalsIgnoreCase(result)){
            flag = "REJECT";
            flagDesc = "审批拒绝";
            cc.setCreditStatus("REJECT");
            fctProjectService.updateByPrimaryKeySelective(requestCtx, cc);
        }else{
            flag = "APPROVED_RETURN";
            flagDesc = "审批退回";
            cc.setCreditStatus("APPROVED_RETURN");
            fctProjectService.updateByPrimaryKeySelective(requestCtx, cc);
        }

   /*     HlsCusFctProjectConFileAprl fctProjectConFileAprl = new HlsCusFctProjectConFileAprl();
        fctProjectConFileAprl.setProjectId(cc.getProjectId());
        fctProjectConFileAprl.setStatus("flag");
        fctProjectConFileAprl.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        fctProjectConFileAprlService.insertSelective(requestCtx, fctProjectConFileAprl);*/


        Long approvalId = (Long) delegateExecution.getVariable("approvalId");

        //更新授信审批表
        HlsCusHlsCreditLineApproval hlsCreditLineApproval = new HlsCusHlsCreditLineApproval();
        hlsCreditLineApproval.setApprovalId(approvalId);
        hlsCreditLineApproval.setCreditLineId(cc.getCreditLineId());
        hlsCreditLineApproval.setStatus(flag);
        hlsCreditLineApproval.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        hlsCreditLineApprovalService.updateByPrimaryKeySelective(requestCtx, hlsCreditLineApproval);


        Map<String, Object> evenParams = new HashMap<>();
        evenParams.put("message", "保理项目" + cc.getProjectNumber() + "授信审批" + flagDesc);
        evenParams.put("noticeTitle", "保理项目授信审批");
        evenParams.put("url", "");
        evenParams.put("level", 1L);
        evenParams.put("noticeType", "NOTICE");
        sysEventService.eventSave(requestCtx, cc.getProjectId(), cc.getDocumentCategory(), cc.getDocumentType(), "FCT", PROPERTY_FCT_PROJECT_CREDIT_SUBMIT, "P2D", evenParams);
    }
}
