package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.fct.dto.HlsCusFctProject;
import hls.core.fct.dto.HlsCusFctProjectApproval;
import hls.core.fct.dto.HlsCusFctProjectQuotation;
import hls.core.fct.dto.HlsCusHlsCreditLineApproval;
import hls.core.fct.mapper.HlsCusFctProjectQuotationMapper;
import hls.core.fct.service.FctProjectApprovalService;
import hls.core.fct.service.FctProjectQuotationService;
import hls.core.fct.service.FctProjectService;
import hls.core.fct.service.HlsCreditLineApprovalService;
import hls.core.prj.dto.HlsCreditLine;
import hls.core.prj.dto.HlsCusHlsCreditLine;
import hls.core.prj.service.HlsCreditLineService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by wangyan on 2017/11/13.
 */
@Component
public class FctProjectSubmitServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private SysUserService userService;
    @Autowired
    private FctProjectService fctProjectService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private FctProjectApprovalService fctProjectApprovalService;
    @Autowired
    private FctProjectQuotationService fctProjectQuotationService;
    @Autowired
    private  HlsCusFctProjectQuotationMapper fctProjectQuotationMapper;
    @Autowired
    private HlsCreditLineService hlsCreditLineService;

    public FctProjectSubmitServiceTask(){}
    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        String fctProjectPrams=(String)delegateExecution.getVariable( "fctProject");
        HlsCusFctProject fctProject=JSON.parseObject(fctProjectPrams,HlsCusFctProject.class);
        HlsCusFctProject resultFctProject=new HlsCusFctProject();
        //根据状态修改立项信息
        resultFctProject.setProjectId(fctProject.getProjectId());
        resultFctProject=fctProjectService.selectByPrimaryKey(requestCtx,resultFctProject);
        databaseLockProvider.lock(resultFctProject);
        if("APPROVED".equalsIgnoreCase(result)){
            flag = "APPROVED";
            //将融资金额会写到已用额度
            HlsCusFctProjectQuotation fctProjectQuotation = new HlsCusFctProjectQuotation();
            fctProjectQuotation.setProjectId(fctProject.getProjectId());
            List<HlsCusFctProjectQuotation> fctProjectQuotationList = fctProjectQuotationMapper.fctProjectQuotationDetailQuery(fctProjectQuotation);
            HlsCusHlsCreditLine hlsCreditLine = new HlsCusHlsCreditLine();
            hlsCreditLine.setCreditLineId(fctProject.getCreditLineId());
            hlsCreditLine = hlsCreditLineService.selectByPrimaryKey(requestCtx,hlsCreditLine);
            if(hlsCreditLine.getCreditExposureAmt()==null){
                hlsCreditLine.setCreditExposureAmt(fctProjectQuotationList.get(0).getFinanceAmount());
            }else{
                hlsCreditLine.setCreditExposureAmt(fctProjectQuotationList.get(0).getFinanceAmount()+hlsCreditLine.getCreditExposureAmt());
            }
            hlsCreditLineService.updateByPrimaryKeySelective(requestCtx,hlsCreditLine);
        }else if("CANCEL".equalsIgnoreCase(result)){
            flag = "CANCEL";
        }else if("REJECTED".equalsIgnoreCase(result)){
            flag = "APPROVED_RETURN";
        }
        //结束流程插入立项审批表
        List<HlsCusFctProjectApproval> hlsCusFctProjectApprovalList=new ArrayList<>();
        HlsCusFctProjectApproval fctProjectApproval=new HlsCusFctProjectApproval();
        fctProjectApproval.setProjectId(fctProject.getProjectId());
        fctProjectApproval.setStatus(flag);
        fctProjectApproval.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        hlsCusFctProjectApprovalList.add(fctProjectApproval);
        fctProjectApprovalService.insertSelective(requestCtx,fctProjectApproval);
        resultFctProject.setProjectStatus(flag);
        fctProjectService.updateByPrimaryKeySelective(requestCtx,resultFctProject);


    }

}
