package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.impl.RequestHelper;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.lon.dto.HlsCusLonContract;
import hls.core.lon.service.ILonContractService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * Created by wangyan on 2017/11/13.
 */
@Component
public class LonContractSubmitServiceTask implements JavaDelegate, IActivitiBean {
    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private SysUserService userService;
    @Autowired
    private ILonContractService lonContractService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    public LonContractSubmitServiceTask(){}
    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        IRequest requestCtx = RequestHelper.getCurrentRequest();
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        SysUser sysUser = userService.queryUserByCode(employeeCode);
        String lonContractPrams = (String)delegateExecution.getVariable("lonContract");
        HlsCusLonContract lonContract = JSON.parseObject(lonContractPrams,HlsCusLonContract.class);
        HlsCusLonContract resultLonContract = new HlsCusLonContract();
        //根据状态修改合同信息
        resultLonContract.setContractId(lonContract.getContractId());
        resultLonContract = lonContractService.selectByPrimaryKey(requestCtx,resultLonContract);
        databaseLockProvider.lock(resultLonContract);
        if("APPROVED".equalsIgnoreCase(result)){
            flag = "APPROVED";
        }else if("CANCEL".equalsIgnoreCase(result)){
            flag = "CANCEL";
        }else if("REJECTED".equalsIgnoreCase(result)){
            flag = "REJECT";
        }
        resultLonContract.setContractStatus(flag);
        lonContractService.updateByPrimaryKeySelective(requestCtx,resultLonContract);
    }

}
