package com.hand.hap.activiti.components;

import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.activiti.exception.InsufficientAmountException;
import hls.core.csh.dto.HlsCusCshTransaction;
import hls.core.csh.dto.TransactionRelation;
import hls.core.csh.mapper.HlsCusCshTransactionMapper;
import hls.core.csh.mapper.TransactionRelationMapper;
import hls.core.hls.components.CalculateUtil;
import hls.core.lon.dto.HlsCusLonContractWithdraw;
import hls.core.lon.mapper.HlsCusLonContractWithdrawMapper;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * Created by fjm on 2017/11/20.
 */
@Component
public class LonWithdrawTransactionServiceTask implements JavaDelegate, IActivitiBean {

    public static final String LON_CONTRACT_WITHDRAW = "LON_CONTRACT_WITHDRAW";//融资提款
    @Autowired
    private TransactionRelationMapper transactionRelationMapper;
    @Autowired
    private HlsCusCshTransactionMapper transactionMapper;
    @Autowired
    private HlsCusLonContractWithdrawMapper lonContractWithdrawMapper;

    @Override
    public void execute(DelegateExecution execution) {
        String approveResult = (String) execution.getVariable("approveResult");
        if ("APPROVED".equalsIgnoreCase(approveResult)) {
            TransactionRelation relation = new TransactionRelation();
            String processInstanceBusinessKey = execution.getProcessInstanceBusinessKey();
            relation.setRelationDocId(Long.parseLong(processInstanceBusinessKey));
            relation.setRelationDocCategory(LON_CONTRACT_WITHDRAW);
            List<TransactionRelation> list = transactionRelationMapper.select(relation);
            HlsCusLonContractWithdraw lonContractWithdraw = lonContractWithdrawMapper.selectByPrimaryKey(Long.parseLong(processInstanceBusinessKey));
            Double totalReceiveAmount = 0D;
            for (TransactionRelation item : list) {
                Long transactionId = item.getTransactionId();
                HlsCusCshTransaction hlsCusCshTransaction = transactionMapper.selectByPrimaryKey(transactionId);
                totalReceiveAmount = CalculateUtil.add(totalReceiveAmount, CalculateUtil.sub(hlsCusCshTransaction.getTransactionAmount(), hlsCusCshTransaction.getWriteOffAmount()));
            }
            if (lonContractWithdraw.getDueAmount() == null || lonContractWithdraw.getDueAmount().compareTo(totalReceiveAmount) == 1) {//判断收款金额是否大于实际结清金额
                try {
                    throw new InsufficientAmountException();
                } catch (InsufficientAmountException e) {
                    throw new RuntimeException(e);
                }
            }
        }

    }
}
