package com.hand.hap.activiti.components;

import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.csh.dto.HlsCusCshPaymentReqHd;
import hls.core.csh.service.ICshPaymentReqHdService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by Administrator on 2017/4/7.
 */
@Component
public class PaymentServiceTask implements JavaDelegate, IActivitiBean {

    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private ICshPaymentReqHdService paymentReqHdService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    public PaymentServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String flag = null;
        Long paymenyRedId = (Long)delegateExecution.getVariable("paymentRedId");
        IRequest requestContext = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");

        SysUser sysUser = userService.queryUserByCode(employeeCode);

        if("APPROVED".equalsIgnoreCase(result))
        {
            flag ="APPROVED";
        }else if("CANCEL".equalsIgnoreCase(result))
        {
            flag ="CANCEL";
        }else
        {
            flag ="REJECTED";
        }
        HlsCusCshPaymentReqHd hd = new HlsCusCshPaymentReqHd();
        hd.setPayment_req_id(paymenyRedId);
        // lock csh_payment_req_hd
        databaseLockProvider.lock(hd);
        hd.setPayment_req_status(flag);
        hd.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        paymentReqHdService.updateByPrimaryKeySelective(requestContext,hd);

        if( sysUser!= null)
        {
            Long userId = Long.valueOf(sysUser.getUserId());
            requestContext.setUserId(userId);
        }

        //业务事件
        Map<String,Object> params = new HashMap<String,Object>();
        String url = "";
        params.put("noticeType","NOTICE");
        params.put("url",url);
        params.put("level",2);
        params.put("noticeTitle","资金-付款申请");
        params.put("message","付款申请事件");
        sysEventService.eventSave(requestContext,paymenyRedId,"CSH_PAYMENT_REQ","PAYMENT_REQ","CSH","CSH_TRANSACTION.PAYMENT_APPLY","P2D",params);

    }
}
