package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import com.hand.hap.core.IRequest;
import com.hand.hap.lock.components.DatabaseLockProvider;
import hls.core.cont.service.ConContractService;
import hls.core.prj.dto.HlsCusHlsCreditLine;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.dto.HlsCusPrjProjectMeeting;
import hls.core.prj.mapper.HlsCusPrjProjectMeetingMapper;
import hls.core.prj.service.HlsCreditLineService;
import hls.core.prj.service.PrjProjectEventService;
import hls.core.prj.service.PrjProjectMeetingService;
import hls.core.prj.service.PrjProjectService;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.event.utils.SysEventCodeUtil;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.JavaDelegate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.Date;


/**
 * Created by Administrator on 2017/4/14.
 */
@Component
public class ProjectServiceTask implements JavaDelegate, IActivitiBean {

    @Autowired
    private ApplicationContext applicationContext;
    @Autowired
    private ConContractService service;
    @Autowired
    private PrjProjectService prjProjectService;
    @Autowired
    private SysUserService userService;
    @Autowired
    private PrjProjectEventService projectEventService;
    @Autowired
    private HlsCreditLineService creditLineService;
    @Autowired
    private HlsCusPrjProjectMeetingMapper projectMeetingMapper;
    @Autowired
    private PrjProjectMeetingService projectMeetingService;
    @Autowired
    private SysEventService sysEventService;
    @Autowired
    private DatabaseLockProvider databaseLockProvider;

    public ProjectServiceTask() {
    }

    @Override
    public void execute(DelegateExecution delegateExecution) {
        String prj = (String)delegateExecution.getVariable("prjProject");
        HlsCusPrjProject prjProject= JSON.parseObject(prj,HlsCusPrjProject.class);

        IRequest requestCtx = (IRequest)delegateExecution.getVariable("iRequest");
        String result = (String)delegateExecution.getVariable("approveResult");
        String employeeCode = (String)delegateExecution.getVariable("startUserName");
        Long projectMeetingId = Long.parseLong(delegateExecution.getVariable("projectMeetingId").toString());
        String eventCode = null;

        SysUser sysUser = userService.queryUserByCode(employeeCode);

        HlsCusPrjProject project=prjProjectService.selectByPrimaryKey(requestCtx,prjProject);
        // lock prj_project
        databaseLockProvider.lock(project);

        if("APPROVED".equalsIgnoreCase(result))
        {
            if("CREDIT_LINE".equalsIgnoreCase(project.getBusinessType()))
            {
                prjProjectService.updatePrjProjectApproved(requestCtx,prjProject,"APPROVED");

                HlsCusHlsCreditLine creditLine = new HlsCusHlsCreditLine();
                creditLine.setSourceDocumentCategory("PRJ_PROJECT");
                creditLine.setSourceDocumentId(prjProject.getProjectId());
                creditLineService.updateCreditLine(creditLine,requestCtx.getUserId());

            }else
            {
                //修改合同状态
                service.projectApproved(requestCtx,prjProject,"APPROVED");
                projectMeetingMapper.updatePrjMeetingStatus(prjProject.getProjectId(),"FINISH",new Date(),requestCtx.getUserId(),"APPROVED");

            }
            eventCode = SysEventCodeUtil.PROPERTY_PRJ_PROJECT_APPROVE;
        }else if("REJECTED".equalsIgnoreCase(result))
        {
            //修改项目状态
            prjProjectService.updatePrjProjectApproved(requestCtx,prjProject,"APPROVED_RETURN");
            projectMeetingMapper.updatePrjMeetingStatus(prjProject.getProjectId(),"FINISH",new Date(),requestCtx.getUserId(),"REJECTED");
            eventCode = SysEventCodeUtil.PROPERTY_PRJ_PROJECT_REJECT;
        }else
        {
            prjProjectService.updatePrjProjectApproved(requestCtx,prjProject,"APPROVED_RETURN");
            eventCode = SysEventCodeUtil.PROPERTY_PRJ_PROJECT_CANCEL;
        }

        HlsCusPrjProjectMeeting projectMeeting = new HlsCusPrjProjectMeeting();
        projectMeeting.setProjectMeetingId(projectMeetingId);
        projectMeeting.setProcessInstanceId(Long.parseLong(delegateExecution.getProcessInstanceId()));
        projectMeetingService.updateByPrimaryKeySelective(requestCtx,projectMeeting);

        if( sysUser!= null)
        {
            Long userId = Long.valueOf(sysUser.getUserId());
            requestCtx.setUserId(userId);
        }
        sysEventService.createEvent(requestCtx, project.getProjectId(), "PRJ_PROJECT", "", null, eventCode);

//        projectEventService.eventSave(requestCtx,eventCode,project);
    }
}
