package com.hand.hap.activiti.components;

import com.alibaba.fastjson.JSON;
import com.hand.hap.activiti.custom.IActivitiBean;
import hls.core.prj.dto.HlsCusPrjProject;
import hls.core.prj.mapper.HlsCusPrjProjectMeetingJudgeMapper;
import hls.core.sys.dto.SysUser;
import hls.core.sys.mapper.SysUserMapper;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.delegate.TaskListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * Created by Administrator on 2017/5/24.
 */
@Component
public class SavePrjMeetingCommentsTask implements TaskListener,IActivitiBean {

    @Autowired
    private HlsCusPrjProjectMeetingJudgeMapper projectMeetingJudgeMapper;
    @Autowired
    private SysUserMapper sysUserMapper;

    @Override
    public void notify(DelegateTask delegateTask) {
        String prj = (String)delegateTask.getExecution().getVariable("prjProject");
        HlsCusPrjProject prjProject= JSON.parseObject(prj,HlsCusPrjProject.class);

        String result = (String)delegateTask.getExecution().getVariable("approveResult");
        String comment = (String)delegateTask.getExecution().getVariable("comment");

        if(delegateTask.getExecution().getVariableInstances().get("assignee") != null)
        {
            String code = delegateTask.getExecution().getVariableInstances().get("assignee").getTextValue();
            SysUser sysUser = sysUserMapper.queryUserByCode(code);
            if(sysUser == null)
            {
                projectMeetingJudgeMapper.updateMeetingResult(prjProject.getProjectId(),result,new Date(),0L,comment);
            }else
            {
                projectMeetingJudgeMapper.updateMeetingResult(prjProject.getProjectId(),result,new Date(),sysUser.getUserId(),comment);
            }
        }
    }
}
