package com.hand.hap.activiti.custom;

import com.hand.hap.activiti.listeners.NotificationApproveListener;
import com.hand.hap.activiti.listeners.NotificationEndListener;
import org.activiti.bpmn.model.ActivitiListener;
import org.activiti.bpmn.model.EndEvent;
import org.activiti.bpmn.model.ImplementationType;
import org.activiti.engine.delegate.ExecutionListener;
import org.activiti.engine.delegate.TaskListener;
import org.activiti.engine.impl.bpmn.parser.BpmnParse;
import org.activiti.engine.impl.bpmn.parser.handler.EndEventParseHandler;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * Created by gaoyang on 17/8/15.
 */
public class CustomEndEventParseHandler extends EndEventParseHandler {
    @Autowired
    private NotificationEndListener notificationEndListener;

    @Override
    protected void executeParse(BpmnParse bpmnParse, EndEvent endEvent) {
        super.executeParse(bpmnParse, endEvent);
        //end event notify
        ActivitiListener activitiListener = new ActivitiListener();
        activitiListener.setEvent(ExecutionListener.EVENTNAME_END);
        activitiListener.setImplementationType(ImplementationType.IMPLEMENTATION_TYPE_INSTANCE);
        activitiListener.setInstance(notificationEndListener);
        endEvent.getExecutionListeners().add(activitiListener);
    }
}
