package com.hand.hap.activiti.custom;

import com.hand.hap.activiti.custom.process.CustomHistoryService;
import com.hand.hap.activiti.custom.task.CustomTaskService;
import org.activiti.engine.HistoryService;
import org.activiti.engine.TaskService;
import org.activiti.spring.SpringProcessEngineConfiguration;

import java.io.InputStream;

/**
 * @author njq.niu@hand-china.com
 */
public class CustomSpringProcessEngineConfiguration extends SpringProcessEngineConfiguration {

    protected TaskService customTaskService = new CustomTaskService(this);
    protected HistoryService customHistoryService = new CustomHistoryService(this);

    public InputStream getMyBatisXmlConfigurationStream() {
        return getResourceAsStream("com/hand/hap/activiti/custom/mappings.xml");
    }

    public void initServices() {
        initService(repositoryService);
        initService(runtimeService);
//        initService(historyService);
        initService(identityService);
//        initService(taskService);
        initService(formService);
        initService(managementService);
        initService(dynamicBpmnService);
//        super.initServices();
        initService(customTaskService);
        initService(customHistoryService);
    }

    public TaskService getTaskService() {
        return customTaskService;
    }

    public HistoryService getHistoryService() {
        return customHistoryService;
    }
}
