package com.hand.hap.activiti.demo.service.impl;

import com.hand.hap.activiti.demo.mapper.DemoVacationMapper;
import com.hand.hap.activiti.dto.DemoVacationHistoryResponse;
import com.hand.hap.activiti.dto.HistoricProcessInstanceResponseExt;
import com.hand.hap.activiti.service.IActivitiService;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import org.activiti.engine.HistoryService;
import org.activiti.engine.history.HistoricProcessInstance;
import org.activiti.rest.common.api.DataResponse;
import org.activiti.rest.service.api.RestResponseFactory;
import org.activiti.rest.service.api.engine.variable.RestVariable;
import org.activiti.rest.service.api.history.HistoricProcessInstanceCollectionResource;
import org.activiti.rest.service.api.runtime.process.ProcessInstanceCreateRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.stereotype.Service;
import com.hand.hap.activiti.demo.dto.DemoVacation;
import com.hand.hap.activiti.demo.service.IDemoVacationService;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class DemoVacationServiceImpl extends BaseServiceImpl<DemoVacation> implements IDemoVacationService {

    @Autowired
    private IActivitiService activitiService;

    @Autowired
    private DemoVacationMapper demoVacationMapper;


    private final String processDefinitionKey = "VACATION_REQUEST";

    //    @Autowired
//    private IDemoVacationService vacationService;
/*
* 创建请假流程将表单存放在act_demo_vacation 表
* */
    @Override
    public void createVacationInstance(IRequest iRequest, DemoVacation demoVacation) {
        demoVacation.setUserCode(iRequest.getEmployeeCode());
        DemoVacation demo = this.insertSelective(iRequest, demoVacation);
        ProcessInstanceCreateRequest instanceCreateRequest = new ProcessInstanceCreateRequest();
        instanceCreateRequest.setBusinessKey(String.valueOf(demo.getId()));
        instanceCreateRequest.setProcessDefinitionKey(processDefinitionKey);
        //添加流程变量
        List<RestVariable> variables = new ArrayList<>();
        RestVariable variable = new RestVariable();
        variable.setName("needDays");
        variable.setType("long");
        variable.setValue(demo.getNeedDays());
        RestVariable variable1 = new RestVariable();
        variable1.setName("iRequest");
        variable1.setValue(iRequest);
        RestVariable variable2 = new RestVariable();
        variable2.setName("documentCategory");
        variable2.setValue("VACATION");
        variables.add(variable);
        variables.add(variable1);
        variables.add(variable2);
        instanceCreateRequest.setVariables(variables);

        activitiService.startProcess(iRequest, instanceCreateRequest);
    }

    /*
    * 查看历史请假记录
    * c*/
    @Override
    public List<DemoVacation> selectVacationHistory(IRequest iRequest) {
        DemoVacation demoVacation = new DemoVacation();
        demoVacation.setUserCode(iRequest.getEmployeeCode());
        List<DemoVacation> demoVacations = demoVacationMapper.select(demoVacation);
        return demoVacations;
    }
}