package com.hand.hap.activiti.util;

import com.hand.hap.core.IRequest;
import hls.core.sys.dto.SysUser;
import hls.core.sys.event.service.SysEventService;
import hls.core.sys.service.SysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.impl.persistence.entity.ExecutionEntity;
import org.activiti.engine.impl.persistence.entity.TaskEntity;
import org.activiti.engine.impl.persistence.entity.UserEntity;
import org.activiti.engine.impl.persistence.entity.data.UserDataManager;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import hls.core.sys.event.utils.*;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by gaoyang on 17/8/15.
 */
public class ActivitiSysEventUtils {

    @Autowired
    private UserDataManager userDataManager;
    @Autowired
    private SysUserService userService;
    @Autowired
    private SysEventService sysEventService;

    //TO_DO AND APPROVE CREATE EVENT
    public void addEvent(DelegateTask delegateTask,String eventCode) {
        TaskEntity task = (TaskEntity) delegateTask;
        String assignee = task.getAssignee();
        if (StringUtils.isNotEmpty(assignee)) {
            UserEntity user = userDataManager.findById(assignee);
            SysUser sysUser = userService.queryUserByCode(user.getId());
            ExecutionEntity taskExecution = task.getExecution();
            String pName = (String) taskExecution.getVariable("pName");
            IRequest iRequest = (IRequest) taskExecution.getVariable("iRequest");
            Long documentId = (Long) taskExecution.getVariable("documentId");
            String documentCategory = (String) taskExecution.getVariable("documentCategory");
            String documentType = (String) taskExecution.getVariable("documentType");
            String approveResultDesc = (String) taskExecution.getVariable("approveResultDesc");
            if (sysUser != null) {
                Long userId = Long.valueOf(sysUser.getUserId());
                iRequest.setUserId(userId);
            }
            String url = "/wfl/wfl_maintenance.view?taskId=" + task.getId() + "&currentProcessInstanceId=" + task.getProcessInstanceId();
            Map<String, Object> params = new HashMap<String, Object>();
            if (approveResultDesc != null) {
                params.put("message", task.getDescription() + "－" + approveResultDesc);
            } else {
                params.put("message", task.getDescription());
            }
            params.put("noticeTitle", "工作流待办" + "-" + pName + "-" + task.getName());
            if(eventCode.equals(SysEventCodeUtil.PROPERTY_WFL_TO_DO)){
                params.put("noticeType", "TODO");
                params.put("level", 1);
            }else{
                params.put("noticeType", "NOTICE");
                params.put("level", 2);
            }

            params.put("url", url);
            params.put("taskId", task.getId());
            params.put("eventCode",eventCode);

            sysEventService.createEvent(iRequest, documentId, documentCategory, documentType, params);
        }
    }

    //start and end create event
    public void addEvent(DelegateExecution delegateExecution,String eventCode){
        IRequest iRequest = (IRequest) delegateExecution.getVariable("iRequest");
        String pName = (String) delegateExecution.getVariable("pName");
        String userCode = (String) delegateExecution.getVariable("initiator");
        SysUser sysUser=null;
        if(userCode!=null){
            sysUser = userService.queryUserByCode(userCode);
        }
        Long documentId = (Long) delegateExecution.getVariable("documentId");
        String documentCategory = (String) delegateExecution.getVariable("documentCategory");
        String documentType = (String) delegateExecution.getVariable("documentType");
        if (sysUser != null) {
            Long userId = Long.valueOf(sysUser.getUserId());
            iRequest.setUserId(userId);
        }
        Map<String, Object> params = new HashMap<String, Object>();
        if(eventCode.equals(SysEventCodeUtil.PROPERTY_WFL_START)){
            params.put("noticeTitle", "工作流待办" + "-" + pName + "-" + "流程开始");
            params.put("message", pName + "-" + "流程开始");
        }else if(eventCode.equals(SysEventCodeUtil.PROPERTY_WFL_FINISH)){
            params.put("noticeTitle", "工作流待办" + "-" + pName + "-" + "流程结束");
            params.put("message", pName + "-" + "流程结束");
        }
        params.put("noticeType", "NOTICE");
        params.put("level", 1);
        params.put("eventCode",eventCode);
        sysEventService.createEvent(iRequest, documentId, documentCategory, documentType, params);
    }

}
