package com.hand.hap.excel.controllers;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.pagehelper.PageHelper;
import com.hand.hap.core.IRequest;
import com.hand.hap.excel.service.IExcelExportService;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.ParseException;

@Controller
public class ExcelExportController extends BaseController {

    @Autowired
    ObjectMapper objectMapper;

    @Autowired
    IExcelExportService excelService;


    /**
     * 用户查询Excel文件的生成情况
     */
    @RequestMapping(value = "/excel/info")
    @ResponseBody
    public ResponseData queryExcelInfo(HttpServletRequest request,@RequestParam(required = false) String status,
                                       @RequestParam(defaultValue = DEFAULT_PAGE) final int page,
                                       @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) final int pageSize) throws ParseException {
        PageHelper.startPage(page, pageSize);
        IRequest iRequest = this.createRequestContext(request);
        return excelService.queryExportInfo(status,iRequest);
    }


    /**
     * 用户通过向A请求filepath，fileName下载文件
     *
     * @param filePath 生成好的Excel文件存放的路径
     * @param fileName 保存出来的文件名
     */
    @RequestMapping(value = "/excel/download")
    public void downloadExcel(@RequestParam String filePath, String fileName, HttpServletRequest request, HttpServletResponse response) {
        excelService.downloadExcel(filePath, fileName, request, response);
    }

    @RequestMapping(value = "/excel/cancel")
    public ResponseData cancelExport(@RequestParam Long id) {
        excelService.cancelExport(id);
        return new ResponseData(true);
    }

}
