package com.hand.hap.excel.service;

import com.hand.hap.core.IRequest;
import com.hand.hap.excel.dto.ExportConfig;
import com.hand.hap.system.dto.ResponseData;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.util.List;
import java.util.Map;

/**
 * Created by yang.
 */
public interface IExcelExportService {

    void exportExcel(String sqlId, ExportConfig exportConfig, HttpServletRequest httpServletRequest,
                     HttpServletResponse httpServletResponse, IRequest iRequest) throws IOException;

    void exportExcel(String sqlId, ExportConfig exportConfig, HttpServletRequest httpServletRequest,
                     HttpServletResponse httpServletResponse, IRequest iRequest, int rowMaxNumber) throws IOException;
    /**
     * 返回指定用户文件的生成情况
     */
    ResponseData queryExportInfo(String status, IRequest iRequest);

    /**
     * 供用户根据filePath提供文件下载
     *
     * @param filePath
     */
    void downloadExcel(String filePath,String fileName, HttpServletRequest request, HttpServletResponse response);

    /**
     * 取消文件生成或下载
     *
     * @param id 导出文件的id
     */
    void cancelExport(Long id);


    /**
     * 保存导出信息到数据表中供文件生成
     */
    void saveExportInfo(String sqlId, IRequest iRequest, ExportConfig config, int rowMaxNumber);
}
