package com.hand.hap.security;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.impl.RequestHelper;
import com.hand.hap.system.dto.UserLogin;
import com.hand.hap.system.mapper.UserLoginMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.authentication.logout.SimpleUrlLogoutSuccessHandler;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Date;

/**
 * Created by fjm on 2018/1/2.
 */
public class CustomLogoutSuccessHandler extends SimpleUrlLogoutSuccessHandler {

    @Autowired
    UserLoginMapper userLoginMapper;
    private Logger logger = LoggerFactory.getLogger(getClass());

    @Override
    public void onLogoutSuccess(HttpServletRequest request, HttpServletResponse response, Authentication authentication) throws IOException, ServletException {

        IRequest iRequest = RequestHelper.getCurrentRequest();
        Object loginIdObj = iRequest.getAttribute(IRequest.FIELD_LOGIN_ID);
        if (loginIdObj instanceof Long) {
            UserLogin userLogin = new UserLogin();
            userLogin.setLoginId((Long) loginIdObj);
            userLogin.setLogoutTime(new Date(System.currentTimeMillis()));
            userLoginMapper.updateByPrimaryKeySelective(userLogin);
        }else{
            logger.debug("logout handler could not found target loginId");
        }
        super.onLogoutSuccess(request, response, authentication);
    }
}
