//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.hand.hap.account.controllers;

import com.hand.hap.account.dto.UserRole;
import com.hand.hap.account.service.IUserRoleService;
import com.hand.hap.core.IRequest;
import com.hand.hap.core.exception.BaseException;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
public class UserRoleController extends BaseController {
    @Autowired
    private IUserRoleService userRoleService;

    public UserRoleController() {
    }

    @RequestMapping(
            value = {"/sys/userrole/submit"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public ResponseData submitUserRole(HttpServletRequest request, @RequestBody List<UserRole> userRoles, BindingResult result) throws BaseException {
        this.getValidator().validate(userRoles, result);
        if(result.hasErrors()) {
            ResponseData requestContext1 = new ResponseData(false);
            requestContext1.setMessage(this.getErrorMessage(result, request));
            return requestContext1;
        } else {
            IRequest requestContext = this.createRequestContext(request);
            return new ResponseData(this.userRoleService.batchUpdate(requestContext, userRoles));
        }
    }
}
