//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.hand.hap.system.controllers.sys;

import com.hand.hap.core.IRequest;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.Language;
import com.hand.hap.system.dto.ResponseData;
import com.hand.hap.system.service.ILanguageService;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/sys/language", "/api/sys/language"})
public class LanguageController extends BaseController {
    @Autowired
    private ILanguageService languageService;

    public LanguageController() {
    }

    @RequestMapping(
            value = {"/query"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public ResponseData query(HttpServletRequest request, Language example, @RequestParam(defaultValue = "1") int page, @RequestParam(defaultValue = "10") int pagesize) {
        IRequest iRequest = this.createRequestContext(request);
        return new ResponseData(this.languageService.select(iRequest, example, page, pagesize));
    }

    @RequestMapping(
            value = {"/submit"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public ResponseData submit(HttpServletRequest request, @RequestBody List<Language> languageList, BindingResult result) {
        ResponseData rd = null;
        try {
            IRequest iRequest = this.createRequestContext(request);
            List<Language> language= this.languageService.submit(iRequest, languageList);
            return new ResponseData(language);
        }catch (Exception e){
            rd = new ResponseData(false);
            rd.setMessage("语言代码不可重复，请重新入");
            return rd;
        }
    }

    @RequestMapping(
            value = {"/remove", "/delete"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<Language> languageList) {
        this.languageService.remove(languageList);
        return new ResponseData();
    }
}
